structure BinaryTree_Code : sig
  val id : 'a -> 'a
  type 'a eq
  val eq : 'a eq -> 'a -> 'a -> bool
  datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta |
    Number_of_int of inta
  val eqa : 'a eq -> 'a -> 'a -> bool
  val leta : 'a -> ('a -> 'b) -> 'b
  val eq_int : inta -> inta -> bool
  val eq_inta : inta eq
  datatype 'a tree = Tip | T of 'a tree * 'a * 'a tree
  val less_int : inta -> inta -> bool
  val less_eq_int : inta -> inta -> bool
  val binsert : ('a -> inta) -> 'a -> 'a tree -> 'a tree
  val split : ('a -> 'b -> 'c) -> 'a * 'b -> 'c
  val snd : 'a * 'b -> 'b
  val fst : 'a * 'b -> 'a
  val eq_Tree : 'a eq -> 'a tree -> 'a tree -> bool
  val wrmrm : 'a eq -> ('a -> inta) -> 'a tree -> 'a tree * 'a
  val remove : 'a eq -> ('a -> inta) -> 'a -> 'a tree -> 'a tree
  val tlookup : ('a -> inta) -> inta -> 'a tree -> 'a option
  val test : inta option
end = struct

fun id x = (fn xa => xa) x;

type 'a eq = {eq : 'a -> 'a -> bool};
val eq = #eq : 'a eq -> 'a -> 'a -> bool;

datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta | Number_of_int of inta;

fun eqa A_ a b = eq A_ a b;

fun leta s f = f s;

fun eq_int (Bit1 k1) (Bit1 k2) = eq_int k1 k2
  | eq_int (Bit1 k1) (Bit0 k2) = false
  | eq_int (Bit0 k1) (Bit1 k2) = false
  | eq_int (Bit0 k1) (Bit0 k2) = eq_int k1 k2
  | eq_int (Bit1 k1) Min = eq_int k1 Min
  | eq_int (Bit0 k1) Min = false
  | eq_int (Bit1 k1) Pls = false
  | eq_int (Bit0 k1) Pls = eq_int k1 Pls
  | eq_int Min (Bit1 k2) = eq_int Min k2
  | eq_int Min (Bit0 k2) = false
  | eq_int Min Min = true
  | eq_int Min Pls = false
  | eq_int Pls (Bit1 k2) = false
  | eq_int Pls (Bit0 k2) = eq_int Pls k2
  | eq_int Pls Min = false
  | eq_int Pls Pls = true
  | eq_int (Number_of_int k) (Number_of_int l) = eq_int k l;

val eq_inta = {eq = eq_int} : inta eq;

datatype 'a tree = Tip | T of 'a tree * 'a * 'a tree;

fun less_int (Bit1 k1) (Bit1 k2) = less_int k1 k2
  | less_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_int (Bit0 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit1 k) Min = less_int k Min
  | less_int (Bit0 k) Min = less_eq_int k Min
  | less_int (Bit1 k) Pls = less_int k Pls
  | less_int (Bit0 k) Pls = less_int k Pls
  | less_int Min (Bit1 k) = less_int Min k
  | less_int Min (Bit0 k) = less_int Min k
  | less_int Min Min = false
  | less_int Min Pls = true
  | less_int Pls (Bit1 k) = less_eq_int Pls k
  | less_int Pls (Bit0 k) = less_int Pls k
  | less_int Pls Min = false
  | less_int Pls Pls = false
  | less_int (Number_of_int k) (Number_of_int l) = less_int k l
and less_eq_int (Bit1 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_eq_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit0 k1) (Bit0 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k) Min = less_eq_int k Min
  | less_eq_int (Bit0 k) Min = less_eq_int k Min
  | less_eq_int (Bit1 k) Pls = less_int k Pls
  | less_eq_int (Bit0 k) Pls = less_eq_int k Pls
  | less_eq_int Min (Bit1 k) = less_eq_int Min k
  | less_eq_int Min (Bit0 k) = less_int Min k
  | less_eq_int Min Min = true
  | less_eq_int Min Pls = true
  | less_eq_int Pls (Bit1 k) = less_eq_int Pls k
  | less_eq_int Pls (Bit0 k) = less_eq_int Pls k
  | less_eq_int Pls Min = false
  | less_eq_int Pls Pls = true
  | less_eq_int (Number_of_int k) (Number_of_int l) = less_eq_int k l;

fun binsert h e Tip = T (Tip, e, Tip)
  | binsert h e (T (t1, x, t2)) =
    (if less_int (h e) (h x) then T (binsert h e t1, x, t2)
      else (if less_int (h x) (h e) then T (t1, x, binsert h e t2)
             else T (t1, e, t2)));

fun split f (a, b) = f a b;

fun snd (a, b) = b;

fun fst (a, b) = a;

fun eq_Tree A_ Tip Tip = true
  | eq_Tree A_ (T (tree1a, aa, tree2a)) (T (tree1, a, tree2)) =
    eq_Tree A_ tree1a tree1 andalso
      (eqa A_ aa a andalso eq_Tree A_ tree2a tree2)
  | eq_Tree A_ Tip (T (tree1, a, tree2)) = false
  | eq_Tree A_ (T (tree1, a, tree2)) Tip = false;

fun wrmrm A_ h (T (t1, x, t2)) =
  (if eq_Tree A_ t2 Tip then (t1, x)
    else (T (t1, x, fst (wrmrm A_ h t2)), snd (wrmrm A_ h t2)));

fun remove A_ h e Tip = Tip
  | remove A_ h e (T (t1, x, t2)) =
    (if less_int (h e) (h x) then T (remove A_ h e t1, x, t2)
      else (if less_int (h x) (h e) then T (t1, x, remove A_ h e t2)
             else (if eq_Tree A_ t1 Tip then t2
                    else let
                           val (t1p, r) = wrmrm A_ h t1;
                         in
                           T (t1p, r, t2)
                         end)));

fun tlookup h k Tip = NONE
  | tlookup h k (T (t1, x, t2)) =
    (if less_int k (h x) then tlookup h k t1
      else (if less_int (h x) k then tlookup h k t2 else SOME x));

val test : inta option =
  tlookup id (Number_of_int (Bit0 (Bit0 (Bit1 Pls))))
    (remove eq_inta id (Number_of_int (Bit1 (Bit1 Pls)))
      (binsert id (Number_of_int (Bit0 (Bit0 (Bit1 Pls))))
        (binsert id (Number_of_int (Bit1 (Bit1 Pls))) Tip)));

end; (*struct BinaryTree_Code*)
